package com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.changeVehicleRegistrationUnit;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yeejoin.amos.boot.module.common.biz.event.CommonPublisher;
import com.yeejoin.amos.boot.module.jg.api.dto.FieldChangeMeta;
import com.yeejoin.amos.boot.module.jg.api.dto.PipelineChangeItemDto;
import com.yeejoin.amos.boot.module.jg.api.entity.JgChangeVehicleRegistrationUnit;
import com.yeejoin.amos.boot.module.jg.api.enums.BusinessTypeEnum;
import com.yeejoin.amos.boot.module.jg.biz.edit.event.BaseBizDataChangeEvent;
import com.yeejoin.amos.boot.module.jg.biz.edit.process.biz.DefaultBizDataChangeHandler;
import com.yeejoin.amos.boot.module.ymt.api.enums.FlowStatusEnum;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;
import org.typroject.tyboot.core.rdbms.orm.entity.BaseEntity;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 车用气瓶变更(过户)登记编辑处理器
 */
@Component
public class ChangeVehicleRegistrationUnitDataChangeHandler extends DefaultBizDataChangeHandler<BaseBizDataChangeEvent> {

    private final ChangeVehicleRegistrationUnitEditUpdateService changeVehicleRegistrationUnitEditUpdateService;

    protected ChangeVehicleRegistrationUnitDataChangeHandler(CommonPublisher routerEventPublisher, ApplicationContext applicationContext, ChangeVehicleRegistrationUnitEditUpdateService changeVehicleRegistrationUnitEditUpdateService) {
        super(routerEventPublisher, applicationContext);
        this.changeVehicleRegistrationUnitEditUpdateService = changeVehicleRegistrationUnitEditUpdateService;
    }

    @Override
    public String canHandleBizType() {
        return BusinessTypeEnum.JG_VEHICLE_GAS_CYLINDER_CHANGE.name();
    }

    @Override
    public List<FieldChangeMeta> postSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData, List<FieldChangeMeta> allChangeColumns, Map<String, List<PipelineChangeItemDto>> pipelineChangeItemMap) {
        return Collections.emptyList();
    }

    @Override
    public Boolean beforeCheck(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {
        return Boolean.TRUE;
    }

    @Override
    public Set<String> getEqs(String applyNo) {
        return changeVehicleRegistrationUnitEditUpdateService.getEqsByApplyNo(applyNo);
    }

    /**
     * 管道专用
     * @param applyNo 单据号
     * 判断数据是实时落库，还是先存到json
     * @return 是否需要临时存储
     */
    @Override
    public Boolean requiresTemporarySave(String applyNo) {
        return false;
    }


    @Override
    public Boolean bizIsFinished(String applyNo) {
        JgChangeVehicleRegistrationUnit jgChangeVehicleRegistrationUnit = changeVehicleRegistrationUnitEditUpdateService.getMainService().getOne(new LambdaQueryWrapper<JgChangeVehicleRegistrationUnit>().eq(JgChangeVehicleRegistrationUnit::getApplyNo, applyNo).select(BaseEntity::getSequenceNbr, JgChangeVehicleRegistrationUnit::getStatus));
        return jgChangeVehicleRegistrationUnit.getStatus().equals(FlowStatusEnum.TO_BE_FINISHED.getName());
    }

    @Override
    public Set<String> getProjectContraptionIds(String applyNo) {
        return Collections.emptySet();
    }

    @Override
    public void preSave(String bizId, String applyNo, ModelType model, Map<String, Object> changeData) {

    }
}
